summaryrefslogtreecommitdiffstats
path: root/tests/ts/kill
diff options
context:
space:
mode:
authorSami Kerola2014-07-14 19:52:05 +0200
committerKarel Zak2014-07-15 13:22:24 +0200
commit558445c93d4b7b2f4cc5bcb80ed13c83bebd02c1 (patch)
tree59a9916ab2f153daf6f03f8c9430eb442ac65acd /tests/ts/kill
parentcfdisk: fix warning usage, improve 's' help (diff)
downloadkernel-qcow2-util-linux-558445c93d4b7b2f4cc5bcb80ed13c83bebd02c1.tar.gz
kernel-qcow2-util-linux-558445c93d4b7b2f4cc5bcb80ed13c83bebd02c1.tar.xz
kernel-qcow2-util-linux-558445c93d4b7b2f4cc5bcb80ed13c83bebd02c1.zip
tests: add kill --queue check
Correction. The final failure to catch signal exit should not use exiter() function. --->8---- From: Sami Kerola <kerolasa@iki.fi> Date: Mon, 14 Jul 2014 18:35:56 +0100 Subject: [PATCH] tests: add kill --queue check Signed-off-by: Sami Kerola <kerolasa@iki.fi>
Diffstat (limited to 'tests/ts/kill')
-rwxr-xr-xtests/ts/kill/options2
-rwxr-xr-xtests/ts/kill/queue53
2 files changed, 53 insertions, 2 deletions
diff --git a/tests/ts/kill/options b/tests/ts/kill/options
index 5af78d969..2c82bbccc 100755
--- a/tests/ts/kill/options
+++ b/tests/ts/kill/options
@@ -51,8 +51,6 @@ try_option -s 1
try_option --signal 1
try_option --signal HUP
try_option --signal SIGHUP
-try_option -s 1 -q 42
-try_option -s 1 --queue 42
try_option -1
try_option -HUP
try_option -SIGHUP
diff --git a/tests/ts/kill/queue b/tests/ts/kill/queue
new file mode 100755
index 000000000..992acf7a6
--- /dev/null
+++ b/tests/ts/kill/queue
@@ -0,0 +1,53 @@
+#!/bin/bash
+
+# This file is part of util-linux.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This file is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+TS_TOPDIR="${0%/*}/../.."
+TS_DESC="queue"
+
+. "$TS_TOPDIR/functions.sh"
+ts_init "$*"
+
+ts_check_test_command "$TS_CMD_KILL"
+ts_check_test_command "$TS_HELPER_SIGRECEIVE"
+
+. "$TS_SELF/kill_functions.sh"
+
+all_ok=true
+
+HELPER_SYMLINK="$(mktemp "${TS_OUTDIR}/quXXXXXXXXXXXXX")"
+ln -sf "$TS_HELPER_SIGRECEIVE" "$HELPER_SYMLINK"
+
+"$HELPER_SYMLINK" >> "$TS_OUTPUT" 2>&1 &
+TEST_PID=$!
+check_test_sigreceive $TEST_PID
+[ $? -eq 1 ] || echo "${HELPER_SYMLINK##*/} helper did not start" >> "$TS_OUTPUT"
+
+"$TS_CMD_KILL" -1 --queue 42 $TEST_PID >> "$TS_OUTPUT" 2>&1
+if [ $? -ne 0 ]; then
+ echo "kill --queue 42 failed" >> "$TS_OUTPUT"
+ all_ok=false
+fi
+wait $TEST_PID
+if [ $? -ne 42 ]; then
+ echo "wait $TEST_PID returned $? instead of 42" >> "$TS_OUTPUT"
+ all_ok=false
+fi
+
+if $all_ok; then
+ echo 'all ok' >> "$TS_OUTPUT"
+fi
+
+rm -f "$HELPER_SYMLINK"
+
+ts_finalize